import java.io.*;
import java.util.regex.*;
import java.net.*;
import java.util.*;

/*
	If you hate this mod and/or me, take a number and get in line.
*/

public class TeamData {
	Hashtable<String, String> config = new Hashtable<String, String>();
	Hashtable<String, Long> playerTimes = new Hashtable<String, Long>();
	Hashtable<String, int[]> players = new Hashtable<String, int[]>();

	String NoDataID = "0";
	String DataID = "0";
	String bracket = "5";

	int TotalPlayers = 0;
	int NeedingUpdate = 0;

	Hashtable<String, String> armories = new Hashtable<String, String>();

	public TeamData() throws Exception {
		armories.put( "us", "http://armory.worldofwarcraft.com/" );
		armories.put( "eu", "http://armory.wow-europe.com/" );
		armories.put( "kr", "http://armory.worldofwarcraft.co.kr/" );

		ParseConfig();
		CheckConfig();

		LoadPlayers();

		BufferedReader in = new BufferedReader( new InputStreamReader( System.in ) );
		while( true ) {
			if( config.containsKey( "top20" ) ) {
				System.out.print( "Choose an option [reconfig/top/status/unknown/update/exit]: " );
			} else {
				System.out.print( "Choose an option [reconfig/unlock/status/unknown/update/exit]: " );
			}

			String line = in.readLine();

			if( line.equals( "reconfig" ) ) {
				config.clear();
				CheckConfig();

				System.out.println();

			} else if( line.equals( "unknown" ) ) {
				CheckUnknown();
				SavePlayers();

				System.out.println();

			} else if( line.equals( "status" ) ) {
				CheckStatus();

				System.out.println();

			} else if( !config.containsKey( "top20" ) && line.equals( "unlock" ) ) {
				UnlockTop20();

				System.out.println();

			// ENABLE THIS AT YOUR OWN RISK
			// This is not meant not to be used by everyone as I do not trust people when it comes to abusing it.
			} else if( config.containsKey( "top20" ) && line.equals( "top" ) ) {
				while( true ) {
					System.out.print( "Choose a bracket [2/3/5]: " );
					line = in.readLine();

					if( line.equals( "5" ) || line.equals( "3" ) || line.equals( "2" ) ) {
						bracket = line;
						break;
					}
				}

				RequestTop20();
				SavePlayers();

				System.out.println();
			} else if( line.equals( "update" ) ) {
				UpdatePlayers();
				SavePlayers();

				System.out.println();
			} else if( line.equals( "exit" ) ) {
				break;
			}
		}
	}

	public void UnlockTop20() throws Exception {
		System.out.println( "This will enable loading of the top 20 arena teams for the specified bracket." );
		System.out.println( "NOTE: Around 80-100 requests are sent out for 2vs2, 100-120 for 3vs3 and 150-170 in order to get the top 20 arena team player talents." );
		System.out.println( "You should not use this frequently or abuse it." );
		System.out.println();

		System.out.print( "Do you still want to unlock this? [yes/no]: " );

		BufferedReader in = new BufferedReader( new InputStreamReader( System.in ) );
		String line = in.readLine();

		if( line.equals( "yes" ) ) {
			System.out.println( "Option has been unlocked, you will need to reconfigure to relock." );

			config.put( "top20", "true" );
			SaveConfig();
		}
	}

	public void CheckStatus() throws Exception {
		System.out.println( "Total players recorded: " + TotalPlayers );
		System.out.println( "Total player talents older then 3 days: " + NeedingUpdate );
	}

	public void GetArenaTeam( String teamName, String battlegroup, String bracket ) throws Exception {
		System.out.println( teamName );

		URL url = new URL( config.get( "armory" ) + "team-info.xml?b=" + battlegroup + "&ts=" + bracket + "&t=" + teamName.replaceAll( " ", "+" ) );
		HttpURLConnection conn = ( HttpURLConnection ) url.openConnection();
		conn.setRequestProperty( "User-Agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.1) Gecko/20061204 Firefox/2.0.0.1" );

		InputStream is = conn.getInputStream();
		StringBuffer sb = new StringBuffer();
		int count = 0;

		while( ( count = is.read() ) != -1 ) {
			sb.append( ( char ) count );
		}

		is.close();
		conn.disconnect();

		Matcher match;
		Pattern character = Pattern.compile( "character battleGroup=\"(.+?)\" charUrl=\"(.+?)\" class=\"(.+?)\" classId=\"(.+?)\" gamesPlayed=\"(.+?)\" gamesWon=\"(.+?)\" gender=\"(.+?)\" genderId=\"(.+?)\" guildId=\"(.+?)\" name=\"(.+?)\" race=\"(.+?)\" raceId=\"(.+?)\" realm=\"(.+?)\" seasonGamesPlayed=\"(.+?)\" seasonGamesWon=\"(.+?)\" teamRank=\"(.+?)\"" );

		String[] lines = sb.toString().split( "\\n" );

		for( String line : lines ) {
			match = character.matcher( line );
			if( match.find() ) {
				String playerName = match.group( 10 );
				String playerServer = match.group( 13 );

				GetPlayerSpec( playerName, playerServer );

				if( players.containsKey( playerName + "-" + playerServer ) ) {
					int[] spec = players.get( playerName + "-" + playerServer );
					System.out.println( " - " + playerName + "-" + playerServer + " (" + spec[0] + "/" + spec[1] + "/" + spec[2] + ")" );
				} else {
					System.out.println( " - ERR Requesting data for " + playerName + "-" + playerServer );
				}
			}
		}
	}

	public void RequestTop20() throws Exception {
		System.out.println( "Requesting the top 20 arena teams for " + config.get( "battlegroup" ) + " " + bracket + "vs" + bracket );
		System.out.println();

		URL url = new URL( config.get( "armory" ) + "arena-ladder.xml?b=" + config.get( "battlegroup" ) + "&ts=" + bracket );
		HttpURLConnection conn = ( HttpURLConnection ) url.openConnection();
		conn.setRequestProperty( "User-Agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.1) Gecko/20061204 Firefox/2.0.0.1" );

		InputStream is = conn.getInputStream();
		StringBuffer sb = new StringBuffer();
		int count = 0;

		while( ( count = is.read() ) != -1 ) {
			sb.append( ( char ) count );
		}

		is.close();
		conn.disconnect();

		Matcher match;
		Pattern arenaTeam = Pattern.compile( "arenaTeam battleGroup=\"(.+?)\" faction=\"(.+?)\" factionId=\"(.+?)\" gamesPlayed=\"(.+?)\" gamesWon=\"(.+?)\" lastSeasonRanking=\"(.+?)\" name=\"(.+?)\" ranking=\"(.+?)\" rating=\"(.+?)\" realm=\"(.+?)\" realmUrl=\"(.+?)\" relevance=\"(.+?)\" seasonGamesPlayed=\"(.+?)\" seasonGamesWon=\"(.+?)\" size=\"(.+?)\" url=\"(.+?)\"" );

		String[] lines = sb.toString().split( "\\n" );

		for( String line : lines ) {
			match = arenaTeam.matcher( line );

			if( match.find() ) {
				String teamName = match.group( 7 );

				GetArenaTeam( teamName, config.get( "battlegroup" ), bracket );
			}
		}
	}

	public void UpdatePlayers() throws Exception {
		System.out.println( "Updating the first 30 players that are out of date by more then 3 days." );
		System.out.println( "Please remember this is opening a connection per a player saved, do not abuse it." );

		Long cutOffTime = System.currentTimeMillis() - ( 60 * 60 * 24 * 3 ) * 1000;

		int i=1;
		for( Enumeration enume = playerTimes.keys(); enume.hasMoreElements(); ) {
			String playerName = ( String ) enume.nextElement();
			Long updateTime = playerTimes.get( playerName );

			if( i > 30 ) {
				break;
			}

			if( updateTime <= cutOffTime ) {
				GetPlayerSpec( playerName );

				if( players.containsKey( playerName ) ) {
					int[] spec = players.get( playerName );
					System.out.println( " - " + playerName + " (" + spec[0] + "/" + spec[1] + "/" + spec[2] + ")" );
				} else {
					System.out.println( " - ERR Requesting data for " + playerName );
				}

				i++;
			}
		}

		if( i == 1 ) {
			System.out.println( "No players need to be updated." );
		}
	}

	public void SavePlayers() throws Exception {
		FileWriter fw = new FileWriter( new File( config.get( "path" ) + "\\Interface\\AddOns\\ArenaSpec\\ArenaSpec_Data.lua" ) );
		DataID = NoDataID;
		TotalPlayers = 0;

		fw.write( "ArenaSpec_DataID = " + NoDataID + "\r\n" );
		fw.write( "ArenaSpec_Data = {\r\n" );

		for( Enumeration enume = players.keys(); enume.hasMoreElements(); ) {
			String playerName = ( String ) enume.nextElement();
			int[] spec = players.get( playerName );

			fw.write( "	[\"" + playerName + "\"] = { " + spec[0] + ", " + spec[1] + ", " + spec[2] + " },\r\n" );
			TotalPlayers++;
		}

		fw.write( "}\r\n" );
		fw.write( "ArenaSpec_Time = {\r\n" );

		for( Enumeration enume = players.keys(); enume.hasMoreElements(); ) {
			String playerName = ( String ) enume.nextElement();

			fw.write( "	[\"" + playerName + "\"] = " );

			if( playerTimes.containsKey( playerName ) ) {
				fw.write( playerTimes.get( playerName ).toString() );
			} else {
				fw.write( System.currentTimeMillis() + "" );
			}

			fw.write( ",\r\n" );
		}

		fw.write( "}" );
		fw.close();
	}

	public void LoadPlayers() throws Exception {
		File file = new File( config.get( "path" ) + "\\Interface\\AddOns\\ArenaSpec\\ArenaSpec_Data.lua" );
		file.createNewFile();

		BufferedReader br = new BufferedReader( new FileReader( file ) );

		String line;
		String openConfig = "";

		Long cutOffTime = System.currentTimeMillis() - ( 60 * 60 * 24 * 3 ) * 1000;

		Matcher match;
		Pattern dataMatch = Pattern.compile( "\\[\"(.+?)\"\\] = \\{ ([0-9]+), ([0-9]+), ([0-9]+) \\}," );
		Pattern timeMatch = Pattern.compile( "\\[\"(.+?)\"\\] = ([0-9]+)," );

		while( ( line = br.readLine() ) != null ) {
			if( line.matches( "ArenaSpec_DataID = ([0-9]+)" ) ) {
				DataID = line.substring( 19 );

			} else if( line.matches( "ArenaSpec_Time = \\{" ) ) {
				openConfig = "time";

			} else if( line.matches( "ArenaSpec_Data = \\{" ) ) {
				openConfig = "data";

			} else if( line.equals( "}" ) ) {
				openConfig = "";

			} else if( openConfig.equals( "time" ) ) {
				match = timeMatch.matcher( line );

				if( match.find() && match.groupCount() == 2 ) {
					Long updatedTime = Long.parseLong( match.group( 2 ) );
					playerTimes.put( match.group( 1 ), updatedTime );

					if( updatedTime <= cutOffTime ) {
						NeedingUpdate++;
					}
				}

			} else if( openConfig.equals( "data" ) ) {
				match = dataMatch.matcher( line );
				if( match.find() && match.groupCount() == 4 ) {
					players.put( match.group( 1 ), new int[]{ Integer.parseInt( match.group( 2 ) ), Integer.parseInt( match.group( 3 ) ), Integer.parseInt( match.group( 4 ) ) } );
					TotalPlayers++;
				}
			}
		}

		if( DataID == null ) {
			DataID = "0";
		}
	}

	public void GetPlayerSpec( String playerName ) throws Exception {
		String[] playerInfo = playerName.split( "-", 3 );

		GetPlayerSpec( playerInfo[0], playerInfo[1] );
	}

	public void GetPlayerSpec( String playerName, String playerRealm ) throws Exception {
		URL url = new URL( config.get( "armory" ) + "character-sheet.xml?r=" + playerRealm.replaceAll( " ", "+" ) + "&n=" + playerName.replaceAll( " ", "+" ) );
		HttpURLConnection conn = ( HttpURLConnection ) url.openConnection();
		conn.setRequestProperty( "User-Agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.1) Gecko/20061204 Firefox/2.0.0.1" );

		InputStream is = conn.getInputStream();
		StringBuffer sb = new StringBuffer();
		int count = 0;

		while( ( count = is.read() ) != -1 ) {
			sb.append( ( char ) count );
		}

		is.close();
		conn.disconnect();

		Pattern talents = Pattern.compile( "<talentSpec treeOne=\"([0-9]+)\" treeThree=\"([0-9]+)\" treeTwo=\"([0-9]+)\"/>" );
		Matcher match = talents.matcher( sb.toString() );

		if( match.find() ) {
			players.put( playerName + "-" + playerRealm, new int[]{ Integer.parseInt( match.group( 1 ) ), Integer.parseInt( match.group( 3 ) ), Integer.parseInt( match.group( 2 ) ) } );
			playerTimes.put( playerName + "-" + playerRealm, System.currentTimeMillis() );
		}
	}

	public void CheckUnknown() throws Exception {
		File file = new File( config.get( "path" ) + "\\WTF\\Account\\" + config.get( "account" ) + "\\SavedVariables\\ArenaSpec.lua" );
		if( !file.exists() ) {
			System.out.println( "It appears that you don't have anything saved yet, did you remember to do a /console reloadui" );
			return;
		}

		BufferedReader br = new BufferedReader( new FileReader( file ) );

		String line;
		int playersLogged = 0;

		Vector<String> unknownPlayers = new Vector<String>();

		Matcher match;
		Pattern dataMatch = Pattern.compile( "\"(.+?)\", -- \\[[0-9]+\\]" );

		while( ( line = br.readLine() ) != null ) {
			if( line.matches( "ArenaSpec_NoDataID = ([0-9]+)" ) ) {
				NoDataID = line.substring( 21 );
			} else {
				match = dataMatch.matcher( line );
				if( match.find() ) {
					unknownPlayers.add( match.group( 1 ) );
					playersLogged++;
				}
			}
		}

		if( NoDataID == null ) {
			NoDataID = "0";
		}

		if( playersLogged == 0 || NoDataID.equals( DataID ) ) {
			System.out.println( "You do not have any unknown players and do not need to do a request." );
			System.out.println( "Remember, you must do a /console reloadui before new unknown players are saved." );
			return;
		}

		System.out.println( "Found " + playersLogged + " unknown players" );

		for( Enumeration enume = unknownPlayers.elements(); enume.hasMoreElements(); ) {
			String playerName = ( String ) enume.nextElement();
			GetPlayerSpec( playerName );

			if( players.containsKey( playerName ) ) {
				int[] spec = players.get( playerName );
				System.out.println( " - " + playerName + " (" + spec[0] + "/" + spec[1] + "/" + spec[2] + ")" );
			} else {
				System.out.println( " - ERR Requesting data for " + playerName );
			}
		}
	}

	public void ParseConfig() throws Exception {
		File file = new File( "./TeamConfig.txt" );
		file.createNewFile();

		BufferedReader br = new BufferedReader( new FileReader( file ) );

		String line;
		while( ( line = br.readLine() ) != null ) {
			String[] data = line.split( "=", 2 );
			config.put( data[0], data[1] );
		}
	}

	public void CheckConfig() throws Exception {
		if( config.containsKey( "armory" ) ) {
			return;
		}

		config.remove( "top20" );

		System.out.println( "We will attempt to auto detect some settings, if you're fine with our option just hit ENTER." );

		String line;
		BufferedReader in = new BufferedReader( new InputStreamReader( System.in ) );

		String path = ( new File( "./" ) ).getCanonicalPath().replaceAll( "\\\\Interface\\\\AddOns\\\\ArenaSpec", "" );

		while( true ) {
			System.out.print( "Path to World of Warcraft [" + path + "]: " );

			line = in.readLine();
			if( line.equals( "" ) ) {
				line = path;
			}

			if( !( new File( line ) ).exists() ) {
				System.out.println( "Cannot find the path " + line );
			} else {
				config.put( "path", line );
				break;
			}
		}

		File dir = new File( config.get( "path" ) + "\\WTF\\Account" );
		while( true ) {
			System.out.print( "Account Name [" + dir.listFiles()[0].getName() + "]: " );
			line = in.readLine();

			if( line.equals( "" ) ) {
				config.put( "account", dir.listFiles()[0].getName() );
				break;

			} else if( ( new File( config.get( "path" ) + "\\WTF\\Account\\" + line.toUpperCase() ) ).exists() ) {
				config.put( "account", line );
				break;

			} else {
				System.out.println( "No account name " + line + " found inside WTF\\Account\\" );
			}
		}

		BufferedReader br = new BufferedReader( new FileReader( config.get( "path" ) + "\\WTF\\Config.wtf" ) );
		String lang = "us";
		String server = "";

		while( ( line = br.readLine() ) != null ) {
			if( line.equals( "SET realmList \"us.logon.worldofwarcraft.com\"" ) ) {
				lang = "us";

			} else if( line.equals( "SET realmList \"eu.logon.worldofwarcraft.com\"" ) ) {
				lang = "eu";

			} else if( line.equals( "SET realmList \"kr.logon.worldofwarcraft.com\"" ) ) {
				lang = "kr";

			} else if( line.matches( "SET realmName \"(.+?)\"" ) ) {
				server = line.substring( 15, line.length() - 1 );
			}
		}

		System.out.print( "Enter the armory URL [" + armories.get( lang ) + "]" );
		line = in.readLine();

		if( line.equals( "" ) ) {
			config.put( "armory", armories.get( lang ) );
		} else {
			config.put( "armory", line );
		}

		System.out.print( "Enter your server name [" + server + "]: " );
		line = in.readLine();

		if( line.equals( "" ) ) {
			config.put( "server", server );
		} else {
			config.put( "server", line );
		}

		System.out.println( "Requesting battlegroups..." );

		URL url = new URL( config.get( "armory" ) + "battlegroups.xml" );
		HttpURLConnection conn = ( HttpURLConnection ) url.openConnection();
		conn.setRequestProperty( "User-Agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.1) Gecko/20061204 Firefox/2.0.0.1" );

		InputStream is = conn.getInputStream();
		StringBuffer sb = new StringBuffer();
		int count = 0;

		while( ( count = is.read() ) != -1 ) {
			sb.append( ( char ) count );
		}

		is.close();
		conn.disconnect();

		Matcher match;
		Pattern groupMatch = Pattern.compile( "battlegroup display=\"(.+?)\" name=\"(.+?)\" sortPosition=\"(.+?)\"" );
		Pattern realmMatch = Pattern.compile( "realm name=\"(.+?)\" nameEN=\"(.+?)\"" );

		Hashtable<String, String> servers = new Hashtable<String, String>();
		Hashtable<String, String> battlegroups = new Hashtable<String, String>();

		String[] lines = sb.toString().split( "\\n" );
		String displayGroup = "";
		String groupName = "";

		for( String text : lines ) {
			match = groupMatch.matcher( text );

			if( match.find() ) {
				displayGroup = match.group( 1 );
				groupName = match.group( 2 );

				battlegroups.put( groupName, displayGroup );
			}

			if( !groupName.equals( "" ) ) {
				match = realmMatch.matcher( text );

				if( match.find() ) {
					servers.put( match.group( 1 ), groupName );
				}
			}
		}

		if( servers.containsKey( config.get( "server" ) ) ) {
			System.out.print( "Enter your battlegroup [" + battlegroups.get( servers.get( config.get( "server" ) ) ) + "]: " );
			line = in.readLine();

			if( !line.equals( "" ) ) {
				config.put( "battlegroup", line );
			} else {
				config.put( "battlegroup", servers.get( config.get( "server" ) ) );
			}
		} else {
			System.out.println( "Cannot find your battlegroup." );

			while( true ) {
				System.out.print( "Enter your battlegroup: " );
				line = in.readLine();

				if( line.equals( "" ) ) {
					config.put( "battlegroup", line );
					break;
				}
			}
		}

		SaveConfig();

		System.out.println( "Done!" );
	}

	public void SaveConfig() throws Exception {
		FileWriter fw = new FileWriter( new File( "./TeamConfig.txt" ) );
		for( Enumeration enume = config.keys(); enume.hasMoreElements(); ) {
			String key = ( String ) enume.nextElement();
			String value = config.get( key );

			fw.write( key + "=" + value + "\r\n" );
		}

		fw.close();
	}

	public static void main( String[] args ) throws Exception {
		new TeamData();
	}
}